
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PE文件结构剖析 / iVAN</title>

    <meta name="description" content="PE文件结构剖析 大家都很清楚,了解可执行文件的结构有多么的重要,DOS下如此,Windows下也同样如此.如果你想加密程序,编写病毒等,了解PE文件结构必是不可缺少的.大家也可能见到很多这方面的资料,但都是从理论上解说一下,很少见到拿一个具体文件开刀的.这里,我就用前面&quot;系列4&quot;中的文件4.EXE为例来剖析一下PE文件格式,因时间关系,不可能一下子就写的很完善,如可行,以后再慢慢补来. ===================================================== ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">PE文件结构剖析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>大家都很清楚，了解可执行文件的结构有多么的重要，DOS下如此，Windows下也同样如此。如果你想加密程序，编写病毒等，了解PE文件结构必是不可缺少的。大家也可能见到很多这方面的资料，但都是从理论上解说一下，很少见到拿一个具体文件开刀的。这里，我就用前面“系列4”中的文件4.EXE为例来剖析一下PE文件格式，因时间关系，不可能一下子就写的很完善，如可行，以后再慢慢补来。</p>
<p>=============================================================== <br />对于本文件，红色外框将文件分成4个部分，各部分的内容是：<br />Ⅰ - 文件头；<br />Ⅱ - 代码段；.text section<br />Ⅲ - 引入表；.rdata section<br />Ⅳ - 数据段；.data section</p>
<p>可以看出，每部分都有大量的垃圾数据，用绿色的叉号进行标注。</p>
<p>我们先从整体看一下文件的结构：(要结合ＰＥ剖析图来看）<br />----------------------------------------------------------<br />1、IMAGE_DOS_HEADER<br />虽然你这是Windows下的程序，但保不准别人会拿它到DOS下执行，当然肯定不是想象的结果啦。该文件头和DOS下可执行文件的文件头基本上是一样的，所以你也可以认为它是一个标准的DOS下的EXE文件，只不过程序执行的结果是显示一个错误信息：This program cannot be run in DOS mode.，意思是这是Windows下的程序，到Windows下用吧！<br />该结构的最后一个元素e_lfanew指示PE文件头的位置，是个重要的数据。<br />对本例，该元素位于文件偏移量是3C的位置，其值是000000B0。<br />2、dos下执行时的程序部分<br />3、dos执行时显示的错误信息<br />4、垃圾数据<br />-----------------------------------------------------------<br />就是PE文件头啦，它是一个IMAGE_NT_HEADERS STRUCT结构<br />5、PE文件标记，db 'PE',0,0<br />6、是一个IMAGE_FILE_HEADER结构<br />7、是一个IMAGE_OPTIONAL_HEADER结构<br />8、是一个IMAGE_DATA_DIRECTORY结构数组，共16项<br />9、是一个IMAGE_SECTION_HEADER结构数据，项数由结构6中 NumberOfSections 确定。<br />本例中位于偏移量B6处，其值是0003<br />-------------------------------------------------------------<br />10、程序的代码部分，也就是.text section的内容<br />-------------------------------------------------------------<br />下面是.rdata section的内容，注意这里的指针值都是“虚拟地址”，即在内存执行时的地址。</p>
<p>11、IDA (Import Address table)用来存放函数的地址值。加载器执行文件时会重写该部分内容，程序中调用dll中的函数就是通过这里转到函数的真正位置的。<br />12、是一个IMAGE_IMPORT_DESCRIPTOR结构数组，项数怎么定呢？<br />这么说吧，假如你的程序中要调用N个动态链接库中的函数，那么项数就是N+1，总后一项结构中的数据全0，表示结束。<br />本例中的程序仅调用Kernell32.dll中的函数，所以此处有两个这样的结构。<br />13、是一个IMAGE_THUNK_DATA结构数组，该结构实际就是一个DWORD值，每个DWORD值指示一个IMAGE_IMPORT_BY_NAME结构，反应程序要调用的函数名。最后一个DWORD值为0，表示结束。<br />14、数据，由12、13中的内容指定。</p>
<p>==============================================================<br />下面是用UltraEdit打开4.exe后的抓图（处理）</p>
<p>若下面没图，点这里，可能还要刷新。</p>
<p>==============================================================<br />下面是用W32dasm反汇编4.exe后的详细内容，供参考：<br />Disassembly of File: 4.exe<br />Code Offset = 00000400, Code Size = 00000200 ;在文件中的偏移量是400H，大小200H（调整后的）<br />Data Offset = 00000800, Data Size = 00000200 ;在文件中的偏移量是800H，大小200H（调整后的）</p>
<p>Number of Objects = 0003 (dec), Imagebase = 00400000h ;section的个数是3，基地址是400000H</p>
<p>Section 相对虚拟地址 在文件中的偏移量 调整后的大小 段属性标记<br />Object01: .text RVA: 00001000 Offset: 00000400 Size: 00000200 Flags: 60000020<br />Object02: .rdata RVA: 00002000 Offset: 00000600 Size: 00000200 Flags: 40000040<br />Object03: .data RVA: 00003000 Offset: 00000800 Size: 00000200 Flags: C0000040</p>
<p>+++++++++++++++++++ IMPORTED FUNCTIONS ++++++++++++++++++<br />Number of Imported Modules = 1 (decimal) ;程序仅调用一dll中的函数</p>
<p>Import Module 001: KERNEL32.dll</p>
<p>+++++++++++++++++++ IMPORT MODULE DETAILS +++++++++++++++</p>
<p>Import Module 001: KERNEL32.dll </p>
<p>Addr:00002064 hint(013D) Name: GetStdHandle ;将调用Kernel32中的三个函数<br />Addr:00002074 hint(02B9) Name: WriteFile ;这个Addr给出的值可不函数的真正地址<br />Addr:00002048 hint(0075) Name: ExitProcess ;执行时加载器会修改这三个值</p>
<p>+++++++++++++++++++ ASSEMBLY CODE LISTING ++++++++++++++++++<br />//********************** Start of Code in Object .text **************<br />Program Entry Point = 00401000 (4.exe File Offset:00001600)</p>
<p>* Possible StringData Ref from Data Obj -&gt;"How are you !"<br />|</p>
<p>//******************** Program Entry Point ********<br />:00401000 6800304000 push 00403000<br />:00401005 E80E000000 call 00401018<br />:0040100A 6A00 push 00000000</p>
<p>* Reference To: KERNEL32.ExitProcess, Ord:0075h<br />|<br />:0040100C E801000000 Call 00401012<br />:00401011 CC int 03</p>
<p>* Referenced by a CALL at Address:<br />|:0040100C <br />|</p>
<p>* Reference To: KERNEL32.ExitProcess, Ord:0075h<br />|<br />:00401012 FF2508204000 Jmp dword ptr [00402008]</p>
<p>* Referenced by a CALL at Address:<br />|:00401005 <br />|<br />:00401018 55 push ebp<br />:00401019 8BEC mov ebp, esp<br />:0040101B 83C4F4 add esp, FFFFFFF4<br />:0040101E 6AF5 push FFFFFFF5</p>
<p>* Reference To: KERNEL32.GetStdHandle, Ord:013Dh<br />|<br />:00401020 E863000000 Call 00401088<br />:00401025 8945FC mov dword ptr [ebp-04], eax<br />:00401028 FF7508 push [ebp+08]<br />:0040102B E820000000 call 00401050<br />:00401030 8945F4 mov dword ptr [ebp-0C], eax<br />:00401033 6A00 push 00000000<br />:00401035 8D45F8 lea eax, dword ptr [ebp-08]<br />:00401038 50 push eax<br />:00401039 FF75F4 push [ebp-0C]<br />:0040103C FF7508 push [ebp+08]<br />:0040103F FF75FC push [ebp-04]</p>
<p>* Reference To: KERNEL32.WriteFile, Ord:02B9h<br />|<br />:00401042 E847000000 Call 0040108E<br />:00401047 8B45F8 mov eax, dword ptr [ebp-08]<br />:0040104A C9 leave<br />:0040104B C20400 ret 0004</p>
<p>:0040104E CC int 03<br />:0040104F CC int 03</p>
<p>* Referenced by a CALL at Address:<br />|:0040102B <br />|<br />:00401050 55 push ebp<br />:00401051 8BEC mov ebp, esp<br />:00401053 53 push ebx<br />:00401054 8B4508 mov eax, dword ptr [ebp+08]<br />:00401057 8D5003 lea edx, dword ptr [eax+03]</p>
<p>* Referenced by a (U)nconditional or (C)onditional Jump at Address:<br />|:0040106F(C)<br />|<br />:0040105A 8B18 mov ebx, dword ptr [eax]<br />:0040105C 83C004 add eax, 00000004<br />:0040105F 8D8BFFFEFEFE lea ecx, dword ptr [ebx+FEFEFEFF]<br />:00401065 F7D3 not ebx<br />:00401067 23CB and ecx, ebx<br />:00401069 81E180808080 and ecx, 80808080<br />:0040106F 74E9 je 0040105A<br />:00401071 F7C180800000 test ecx, 00008080<br />:00401077 7506 jne 0040107F<br />:00401079 C1E910 shr ecx, 10<br />:0040107C 83C002 add eax, 00000002</p>
<p>* Referenced by a (U)nconditional or (C)onditional Jump at Address:<br />|:00401077(C)<br />|<br />:0040107F D0E1 shl cl, 1<br />:00401081 1BC2 sbb eax, edx<br />:00401083 5B pop ebx<br />:00401084 C9 leave<br />:00401085 C20400 ret 0004</p>
<p>* Referenced by a CALL at Address:<br />|:00401020 <br />|</p>
<p>* Reference To: KERNEL32.GetStdHandle, Ord:013Dh<br />|<br />:00401088 FF2500204000 Jmp dword ptr [00402000] ;转去IDA表中对应的函数</p>
<p>* Reference To: KERNEL32.WriteFile, Ord:02B9h<br />|<br />:0040108E FF2504204000 Jmp dword ptr [00402004]</p>
<p>==============================================================<br />下面是PE文件剖析时设计到的结构，来自Windows.inc文件，供参考：</p>
<p>IMAGE_DOS_HEADER STRUCT<br />e_magic WORD ?<br />e_cblp WORD ?<br />e_cp WORD ?<br />e_crlc WORD ?<br />e_cparhdr WORD ?<br />e_minalloc WORD ?<br />e_maxalloc WORD ?<br />e_ss WORD ?<br />e_sp WORD ?<br />e_csum WORD ?<br />e_ip WORD ?<br />e_cs WORD ?<br />e_lfarlc WORD ?<br />e_ovno WORD ?<br />e_res WORD 4 dup(?)<br />e_oemid WORD ?<br />e_oeminfo WORD ?<br />e_res2 WORD 10 dup(?)<br />e_lfanew DWORD ?<br />IMAGE_DOS_HEADER ENDS</p>
<p>IMAGE_NT_HEADERS STRUCT<br />Signature DWORD ?<br />FileHeader IMAGE_FILE_HEADER &lt;&gt;<br />OptionalHeader IMAGE_OPTIONAL_HEADER32 &lt;&gt;<br />IMAGE_NT_HEADERS ENDS</p>
<p>IMAGE_FILE_HEADER STRUCT<br />Machine WORD ?<br />NumberOfSections WORD ?<br />TimeDateStamp DWORD ?<br />PointerToSymbolTable DWORD ?<br />NumberOfSymbols DWORD ?<br />SizeOfOptionalHeader WORD ?<br />Characteristics WORD ?<br />IMAGE_FILE_HEADER ENDS</p>
<p>IMAGE_NUMBEROF_DIRECTORY_ENTRIES equ 16</p>
<p>IMAGE_OPTIONAL_HEADER32 STRUCT<br />Magic WORD ?<br />MajorLinkerVersion BYTE ?<br />MinorLinkerVersion BYTE ?<br />SizeOfCode DWORD ?<br />SizeOfInitializedData DWORD ?<br />SizeOfUninitializedData DWORD ?<br />AddressOfEntryPoint DWORD ?<br />BaseOfCode DWORD ?<br />BaseOfData DWORD ?<br />ImageBase DWORD ?<br />SectionAlignment DWORD ?<br />FileAlignment DWORD ?<br />MajorOperatingSystemVersion WORD ?<br />MinorOperatingSystemVersion WORD ?<br />MajorImageVersion WORD ?<br />MinorImageVersion WORD ?<br />MajorSubsystemVersion WORD ?<br />MinorSubsystemVersion WORD ?<br />Win32VersionValue DWORD ?<br />SizeOfImage DWORD ?<br />SizeOfHeaders DWORD ?<br />CheckSum DWORD ?<br />Subsystem WORD ?<br />DllCharacteristics WORD ?<br />SizeOfStackReserve DWORD ?<br />SizeOfStackCommit DWORD ?<br />SizeOfHeapReserve DWORD ?<br />SizeOfHeapCommit DWORD ?<br />LoaderFlags DWORD ?<br />NumberOfRvaAndSizes DWORD ?<br />DataDirectory IMAGE_DATA_DIRECTORY IMAGE_NUMBEROF_DIRECTORY_ENTRIES dup(&lt;&gt;)<br />IMAGE_OPTIONAL_HEADER32 ENDS</p>
<p>IMAGE_OPTIONAL_HEADER equ </p>
<p>IMAGE_DATA_DIRECTORY STRUCT<br />VirtualAddress DWORD ?<br />isize DWORD ?<br />IMAGE_DATA_DIRECTORY ENDS</p>
<p>IMAGE_SIZEOF_SHORT_NAME equ 8</p>
<p>IMAGE_SECTION_HEADER STRUCT<br />Name1 db IMAGE_SIZEOF_SHORT_NAME dup(?)<br />union Misc<br />PhysicalAddress dd ?<br />VirtualSize dd ?<br />ends<br />VirtualAddress dd ?<br />SizeOfRawData dd ?<br />PointerToRawData dd ?<br />PointerToRelocations dd ?<br />PointerToLinenumbers dd ?<br />NumberOfRelocations dw ?<br />NumberOfLinenumbers dw ?<br />Characteristics dd ?<br />IMAGE_SECTION_HEADER ENDS</p>
<p>IMAGE_IMPORT_DESCRIPTOR STRUCT<br />union<br />Characteristics dd ?<br />OriginalFirstThunk dd ?<br />ends<br />TimeDateStamp dd ?<br />ForwarderChain dd ?<br />Name1 dd ?<br />FirstThunk dd ?<br />IMAGE_IMPORT_DESCRIPTOR ENDS</p>
<p>IMAGE_IMPORT_BY_NAME STRUCT<br />Hint dw ?<br />Name1 db ?<br />IMAGE_IMPORT_BY_NAME ENDS</p>
<p>IMAGE_THUNK_DATA32 STRUCT<br />union u1<br />ForwarderString dd ?<br />Function dd ?<br />Ordinal dd ?<br />AddressOfData dd ?<br />ends<br />IMAGE_THUNK_DATA32 ENDS</p>
<p>IMAGE_THUNK_DATA EQU</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 14:43:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/word/" title="word">word</a>, <a href="https://www.iamivan.net/tag/%e7%bb%93%e6%9e%84/" title="结构">结构</a>, <a href="https://www.iamivan.net/tag/dword/" title="DWORD">DWORD</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>PE文件结构剖析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0R6vAz.html" rel="bookmark">《C&plus;&plus; 黑客编程揭秘与防范（第2版）》&mdash;&mdash;6&period;1 PE文件结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.1 PE文件结构 C++ 黑客编程揭秘与防范(第2版) PE(Portable Executable),即可移植的执行体.在Windows平台(包括Win 9x.Win NT.Win CE--)下,所有的可执行文件(包括EXE文件.DLL文件.SYS文件.OCX文件.COM文件--)均使用PE文件结构.这些使用PE文件结构的可执行文件也称为PE文件. 普通的程序员也许没有必要掌握PE文件结构,因为其大多是开发服务性.决策性.辅助性的软件,比如MIS.HIS.CRM等软件.但是对于学习黑客编程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baBm3QM.html" rel="bookmark">《C&plus;&plus; 黑客编程揭秘与防范（第2版）》&mdash;&mdash;6&period;2 详解PE文件结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.2 详解PE文件结构 C++ 黑客编程揭秘与防范(第2版) PSDK的头文件Winnt.h包含了PE文件结构的定义格式.PE头文件分为32位和64位版本.64位的PE结构是对32位的PE结构做了扩展,这里主要讨论32位的PE文件结构.对于64位的PE文件结构,读者可以自行查阅资料进行学习. 6.2.1 DOS头部详解IMAGE_DOS_HEADER 对于一个PE文件来说,最开始的位置就是一个DOS程序.DOS程序包含了一个DOS头部和一个DOS程序体.DOS头部是用来装载DOS程序的,DOS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQk2qKp.html" rel="bookmark">《C&plus;&plus; 黑客编程揭秘与防范（第2版）》&mdash;第6章6&period;2节详解PE文件结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.2 详解PE文件结构C++ 黑客编程揭秘与防范(第2版)PSDK的头文件Winnt.h包含了PE文件结构的定义格式.PE头文件分为32位和64位版本.64位的PE结构是对32位的PE结构做了扩展,这里主要讨论32位的PE文件结构.对于64位的PE文件结构,读者可以自行查阅资料进行学习. 6.2.1 DOS头部详解IMAGE_DOS_HEADER对于一个PE文件来说,最开始的位置就是一个DOS程序.DOS程序包含了一个DOS头部和一个DOS程序体.DOS头部是用来装载DOS程序的,DOS程序也			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGxPvb.html" rel="bookmark">通用ShellCode深入剖析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言: 在网上关于ShellCode编写技术的文章已经非常之多,什么理由让我再写这种 技术文章呢?本文是我上一篇溢出技术文章&lt;Windows 2000缓冲区溢出技术原理&gt;的姊妹 篇,同样的在网上我们经常可以看到一些关于ShelCode编写技术的文章,似乎没有为初学者准 备的,在这里我将站在初学者的角度对通用ShellCode进行比较详细的分析,有了上一篇的溢出 理论和本篇的通用ShellCode理论,基本上我们就可以根据一些公布的Window溢出漏洞或是自 己对一些软件系统进行反汇编分析出的溢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4LKxp.html" rel="bookmark">关于PE可执行文件的修改</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在windows 9x.NT.2000下,所有的可执行文件都是基于Microsoft设计的一种新的文件格式Portable Executable File Format(可移植的执行体),即PE格式.有一些时候,我们需要对这些可执行文件进行修改,下面文字试图详细的描述PE文件的格式及对PE格式文件的修改. 1.PE文件框架构成 DOS MZ headerDOS stubPE headerSection tableSection 1Section 2Section ...Section n 上表是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M62yoAM.html" rel="bookmark">查看PE文件内容的小工具&mdash;&mdash;CliPeViewer</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				CliPeViewer是老刘编写的一个WinForm小程序,能够用来查看托管PE文件中的 各种结构.目前有很多能够查看PE信息的程序,支持.NET的也有.不过, CliPeViewer与他们的最大区别在于,这个小程序更在意原汁原味地暴露一个PE文 件中的内容,尤其是对于文件中的每个结构.每个字段,除了显示了它的值之外 ,还显示出了它在PE文件中的偏移量和原始数据. 坦率地说,CliPeViewer还没有写完.尚欠缺的功能包括:显示IL指令.托管 方法的定义(方法头.异常处理块等),以及对元数据签			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjQqPmz.html" rel="bookmark">《C&plus;&plus; 黑客编程揭秘与防范（第2版）》&mdash;第6章6&period;4节PE相关编程实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.4 PE相关编程实例 C++ 黑客编程揭秘与防范(第2版) 前面讲的都是概念性的知识,本节主要编写一些关于PE文件结构的程序代码,以帮助读者加强对PE结构的了解. 6.4.1 PE查看器 写PE查看器并不是件复杂的事情,只要按照PE结构一步一步地解析就可以了.下面简单地解析其中几个字段内容,显示一下节表的信息,其余的内容只要稍作修改即可.PE查看器的界面如图6-26所示. PE查看器的界面按照图6-26所示的设置,不过这个可以按照个人的偏好进行布局设置.编写该PE查看器的步骤为打开文件并创建			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M94Pnob.html" rel="bookmark">《C&plus;&plus; 黑客编程揭秘与防范（第2版）》&mdash;第6章6&period;3节PE结构的3种地址</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.3 PE结构的3种地址 C++ 黑客编程揭秘与防范(第2版) 在上一章中用OD调试器调试程序时看到的地址与本章使用C32Asm以十六进制形式查看程序时的地址形式有所差异.程序在内存中与在文件中有着不同的地址形式,而且PE相关的地址不只有这两种形式.与PE结构相关的地址形式有3种,且这3种地址形式可以进行转换. 6.3.1 与PE结构相关的3种地址 与PE结构相关的3种地址是VA(虚拟地址).RVA(相对虚拟地址)和FileOffset(文件偏移地址). VA(虚拟地址):PE文件映射到内存后			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJARVvp.html" rel="bookmark">《C&plus;&plus; 黑客编程揭秘与防范（第2版）》&mdash;&mdash;6&period;3 PE结构的3种地址</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.3 PE结构的3种地址 C++ 黑客编程揭秘与防范(第2版) 在上一章中用OD调试器调试程序时看到的地址与本章使用C32Asm以十六进制形式查看程序时的地址形式有所差异.程序在内存中与在文件中有着不同的地址形式,而且PE相关的地址不只有这两种形式.与PE结构相关的地址形式有3种,且这3种地址形式可以进行转换. 6.3.1 与PE结构相关的3种地址 与PE结构相关的3种地址是VA(虚拟地址).RVA(相对虚拟地址)和FileOffset(文件偏移地址). VA(虚拟地址):PE文件映射到内存后			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnPAbG.html" rel="bookmark" class="title">JS实现浏览器菜单命令</a>
					<div>
						js|菜单|浏览器 每当我们看到别人网页上的打开.打印.前进.另存为.后退.关闭本窗口.禁用右键等实现浏览器命令的链接,而自己苦于不能实现时,是不是感到很遗憾?是不是也想实现?如果能在网页上能实现浏览 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM62mYM.html" rel="bookmark" class="title">软件工程之概述</a>
					<div>
						       人生总是在不断的经历,又不断的前进,敲机房收费系统你百感交集,但收获后的喜悦让你嘴角扬起弧线,机房收费系统宛如IT路上的一瞥惊鸿,那一种莫名的纠结,那一个个窗体的交融,滋生出万般滋味,来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDYvBb.html" rel="bookmark" class="title">操作一条数据的两个入口，如何实现web应用？</a>
					<div>
						问题描述 操作一条数据的两个入口,如何实现web应用? 目前的需求是这样的,用户可以自己删除自己的文档,管理员也能删除所有人的文档,那么当用户和管理员操作一条记录的时候应该会有问题的吧?会有这样的问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPWYDM.html" rel="bookmark" class="title">android-expandablelistview中自定义的child无法点击</a>
					<div>
						问题描述 expandablelistview中自定义的child无法点击 写了一个自定义的expandablelistviewgroup设置监听事件,能被点击child setOnChildClic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnLOWb.html" rel="bookmark" class="title">ASP&period;NET生成eurl&period;axd Http异常错误的处理方法</a>
					<div>
						在IIS6中同时启用了ASP.NET 2.0 和 ASP.NET 4.0 后,网站程序可能会出现如下错误:&quot; System.Web.HttpException: Path '//eurl.a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7lQKb.html" rel="bookmark" class="title">精彩的国外的插图在网站设计中运用实例</a>
					<div>
						如果你想给你的网站设计添加一些趣味,那么可以考虑引入一些插图.下面是一些在网站中使用插图的很棒的实例. 1. Jason Gray 2. BEN 3. Tor Web 4. i-avion 5. In ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jYXBb.html" rel="bookmark" class="title">对HDS AMS 2000&amp;amp&semi;gt&semi;&plus;的巡检案例</a>
					<div>
						1. 使用工具:笔记本,网线一根, 2. 使用软件:vmware虚拟机(安装XP P2系统,最好为P3),HSNM2-1152-W- CLI-P01.exe(AMS 200管理软件),jre-6u33 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL6Vab.html" rel="bookmark" class="title">Photoshop制作幽默风格的圣诞海报</a>
					<div>
						  听说2015圣诞节快到了,赶紧做一个圣诞节海报吧-没构思没想法?我来告诉你怎么快速构图做一张属于自己的圣诞海报吧! 最终效果 一.画面构思: 二.使用素材: 三.开始制作:一个画面里,有近景/中景 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8rrKb.html" rel="bookmark" class="title">一键同步Windows 7的视图设置</a>
					<div>
						  Windows 7的个性之一就是提供了文件夹的单独视图设置,不过,如果你想让Windows7所有的文件夹都使用同一种视图设置的话,实现的方法也非常简单. 在任意文件夹中通过&quot;更改您的视图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EvWaM.html" rel="bookmark" class="title">如何删除Windows7系统盘下的索引记录文档</a>
					<div>
						  操作步骤 Windows7的搜索功能因为有了索引而变得异常强大,在建立索引的时候,系统会在C:ProgramDataMicrosoftSearchData建立索引存档,如果你无意使用过搜索索引,或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxLYRb.html" rel="bookmark" class="title">dll调用-古老的vb6&period;0控件滚动条失效</a>
					<div>
						问题描述 古老的vb6.0控件滚动条失效 最近在网上寻找到一款古老的绘图控件,即Vicontour4.5,绘制三维云图,控件为.ocx格式,以及两个dll文件,我在注册了这个控件后,在vs2015中调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEgO5p.html" rel="bookmark" class="title">求大神帮做一个小程序~~~</a>
					<div>
						问题描述 要求:1.以往账单保存下来2.输出电表上上个月数据和本月数据,算出结果----------------求大神~~~~· 解决方案 解决方案二:需求一点也不明确,怎么帮你弄.解决方案三:就是这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW26dGb.html" rel="bookmark" class="title">android-http的get和post请求怎么写</a>
					<div>
						问题描述 http的get和post请求怎么写 如题 http的get和post请求怎么写,最好有具体的代码 解决方案 http://www.jikexueyuan.com/course/188.ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrXq1M.html" rel="bookmark" class="title">Oracle 12C优化器的巨大变化，上生产必读（下）</a>
					<div>
						在Oracle 12c数据库中,随着新的查询优化自适应方法的引入,还有对可用的统计信息的强化,优化器实现了一个巨大的飞跃.今天就让我们继续这个话题,一起来揭晓Oracle 12C其他的强大功能吧. 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/pn72GZz.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vZXNzYXkuYjAudXBhaXl1bi5jb20vMTc0Ny8zNjc1MzgvMC5qcGc=.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/pn72GZz.html" rel="bookmark" class="title">来自百度商业数据可视化团队的js图表控件-ECharts</a>
					<div>
						本人项目中最近有需要图表的地方,偶然发现一款超级漂亮的动态图标js图表控件,分享给大家,觉得好用的就看一下.更多更漂亮的演示大家可以参考下面两个网址: ECharts官方网址:http://ecomf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl28qp.html" rel="bookmark" class="title">C&num;的网页中显示ffmpeg转换视频的进度条</a>
					<div>
						问题描述 C#的网页中显示ffmpeg转换视频的进度条 公司的网站中使用了red视频服务器,后台调用ffmpeg做视频转换,现在想在转换的网页中加一个进度条,搜了很多资料都是winform的进度条.请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqdrjz.html" rel="bookmark" class="title">dmalloc用法快速入门</a>
					<div>
						原文链接 常用内存泄露检测手段有 1 mtrace 2 memwatch 3 mpatrol 4 dmalloc 5 dbgmem 6 valgrind 7 Electric Fence dmallo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rG9gz.html" rel="bookmark" class="title">数据类型转换</a>
					<div>
						问题描述 string类型如何转化为uniqueidentifier类型 解决方案 解决方案二:uniqueidentifier?sqlserver里面的标识列?解决方案三:newGuid(strin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwRe8M.html" rel="bookmark" class="title">如何追溯 PostgreSQL 慢查询当时的状态</a>
					<div>
						数据库出现慢查询的原因很多,例如IO等待,CPU繁忙,执行计划异常,锁等待,等等.那么在发生慢查询后,如何能追溯慢查询当时的状态呢?下面给大家提供一种思路,.1. 首先,我们是如何监测慢查询的.2.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqvVyb.html" rel="bookmark" class="title">Win7在部分性能上略占优势</a>
					<div>
						[科技讯]10月16日消息,据国外媒体报道,近日美国CNET实验室对微软Windows品牌下的新旧产品进行了各项比较.结果显示,Win7的性能并没有被Win8全面压倒,反而在部分性能上略占优势. 我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJnN5p.html" rel="bookmark" class="title">api-百度地图API 怎么去掉默认的起点的点击事件啊？谢谢各位大大</a>
					<div>
						问题描述 百度地图API 怎么去掉默认的起点的点击事件啊?谢谢各位大大 解决方案 查查BaiduMap的API文档					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xGgZb.html" rel="bookmark" class="title">javascript-求助，Qt能不能监测鼠标点击的内容？比如某几个特定的链接</a>
					<div>
						问题描述 求助,Qt能不能监测鼠标点击的内容?比如某几个特定的链接 正在学习使用Qt,想写一个程序,就是每次鼠标点击特定的链接或者某个特定网页上 的按钮就记录下时间和链接内容,这些Qt可以做到吗?需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyK2Nz.html" rel="bookmark" class="title">c&num; 录屏功能实现求解-C&num;录屏功能如何实现求解</a>
					<div>
						问题描述 C#录屏功能如何实现求解 跪求!C# 除了引用WMEncoderLib.dll做录屏之外,还有没有其他能用来做录屏的方式,实在没招了 解决方案 51aspx上记得见过 去找找代码吧					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6EVgM.html" rel="bookmark" class="title">Android实战教程第四篇之简单实现短信发送器&lowbar;Android</a>
					<div>
						本文实例为大家分享了Android发短信功能的实现方法,供大家参考,具体内容如下 首先配置一个布局: &lt;LinearLayout xmlns:android=&quot;http://schem ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Z6Arb.html" rel="bookmark" class="title">Java正则表达式提取字符的方法实例&lowbar;正则表达式</a>
					<div>
						正好遇到一个需求需要将字符串中特定的字符全部提取出来,这个如果是按常规的字符串处理的话非常的繁琐.于是想到用正则表达式来完成.项目需求是这样的:需要提取车牌号中最后一个数字,比如说:苏A7865提取5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXXBlz.html" rel="bookmark" class="title">2017年五大关键云趋势：容器、AI等</a>
					<div>
						不可否认,云计算已经改变了大小型企业的运营模式. 一项来自思科的最新市场分析表明,未来5年内全球云IP流量将以2015年至2020年间30%的年复合增长率增长,预计增长近四倍(3.7倍). 随着云市场 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVd9OBM.html" rel="bookmark" class="title">美中能源战开局：谁在补贴新能源</a>
					<div>
						本报记者 王晓明 北京报道 10月15日,美国贸易代表罗恩·柯克(Ron Kirk)发出声明表示,将应美国钢铁工人联合会的申请,启动对中国政府对本国清洁能源行业不公平支持的&quot;301调查&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWlQ6p.html" rel="bookmark" class="title">微软Outlook整合Facebook等社交网站信息更新</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 北京时间2月18日消息,据国外媒体报道,微软周三对外发布了名为&quot;Outlook社交连接器&quot;(Outlook Social Conne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4EGjb.html" rel="bookmark" class="title">粤传媒&lpar;002181&rpar;均线多头排列反弹走势或延续</a>
					<div>
						博股通金 黎天启 公司是广州日报报业集团控股的上市公司,三大主业为经营广告代理及制作.印刷.书刊零售,目前拥有世界一流的先进设备及珠三角地区领先的印刷规模.公司拥有&lt;广州日报&gt;招聘广告10 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBW6Lb.html" rel="bookmark" class="title">c&plus;&plus;-C&plus;&plus;类的组合编程问题求帮忙</a>
					<div>
						问题描述 C++类的组合编程问题求帮忙 设计出生日期类birthday: year,month,day 设计学生类student: No(学号) ,Name(姓名),Birth(生日),Score(成 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
